package cn.com.ctop.toutiao.modules.adlab.controller;

import cn.com.ctop.common.module.annotation.AutoLog;
import cn.com.ctop.common.module.utils.QueryGenerator;
import cn.com.ctop.toutiao.modules.adlab.entity.CtopAdlabProject;
import cn.com.ctop.toutiao.modules.adlab.service.ICtopAdlabProjectService;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;

/**
 * 投放管家项目列表
 */
@Slf4j
@RestController
@RequestMapping("/adlab/ctopAdlabProject")
public class CtopAdlabProjectController {
    @Autowired
    private ICtopAdlabProjectService ctopAdlabProjectService;

    /**
     * 分页列表查询
     */
    @GetMapping(value = "/list")
    public Result<IPage<CtopAdlabProject>> queryPageList(CtopAdlabProject ctopAdlabProject,
                                                         @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                         @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                         HttpServletRequest req) {
        Result<IPage<CtopAdlabProject>> result = new Result<>();
        QueryWrapper<CtopAdlabProject> queryWrapper = QueryGenerator.initQueryWrapper(ctopAdlabProject, req.getParameterMap());
        Page<CtopAdlabProject> page = new Page<>(pageNo, pageSize);
        IPage<CtopAdlabProject> pageList = ctopAdlabProjectService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     */
    @PostMapping(value = "/add")
    public Result<CtopAdlabProject> add(@RequestBody CtopAdlabProject ctopAdlabProject) {
        Result<CtopAdlabProject> result = new Result<>();
        try {
            ctopAdlabProjectService.save(ctopAdlabProject);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     */
    @PostMapping(value = "/edit")
    public Result<CtopAdlabProject> edit(@RequestParam JSONArray accountIds,
                                         @RequestParam JSONArray groupIds,
                                         @RequestParam String optStatus) {
        Result<CtopAdlabProject> result = new Result<CtopAdlabProject>();


        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "投放管家项目列表-通过id删除")
    @ApiOperation(value = "投放管家项目列表-通过id删除", notes = "投放管家项目列表-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            ctopAdlabProjectService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "投放管家项目列表-批量删除")
    @ApiOperation(value = "投放管家项目列表-批量删除", notes = "投放管家项目列表-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<CtopAdlabProject> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<CtopAdlabProject> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.ctopAdlabProjectService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "投放管家项目列表-通过id查询")
    @ApiOperation(value = "投放管家项目列表-通过id查询", notes = "投放管家项目列表-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<CtopAdlabProject> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<CtopAdlabProject> result = new Result<>();
        CtopAdlabProject ctopAdlabProject = ctopAdlabProjectService.getById(id);
        if (ctopAdlabProject == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(ctopAdlabProject);
            result.setSuccess(true);
        }
        return result;
    }


}
